#ifndef DFPFSMDEV_H
#define DFPFSMDEV_H

#include <optional>

#include "base/DeviceIndex.h"
#include "fsm/BaseFsm.h"

#include "DfpTask.h"
#include "DfpFileTypes.h"

struct DevFlashFsmInput : public BaseFsmInput
{
    std::optional<DFP_TASK> task;
    DFP_FILE fileStatus = DFP_FILE_INVALID;
    bool online = false;
    bool allowTransit = true;
};

class DfpFsmDev : public BaseFsm
{
    Q_OBJECT
public:
    explicit DfpFsmDev(const DeviceIndex &i, QObject *parent = nullptr);

public slots:
    void setFileStatus(DFP_FILE fileValid);
    void setDeviceOnline(bool online);
    void setAllowTransit(bool v);
//    void setMainSetupKey(int key);
//    void setDevSetupKey(const DeviceIndex &index, int key);

signals:
//    void deviceListChanged(const DeviceIndexEnabledMap &);

protected slots:
    virtual bool evaluate() override;

protected:
    virtual void printInputString(QDebug dbg) const override;
    virtual qint64 stateTimeoutMs(const FsmState &state) const override;
    inline DevFlashFsmInput *getInput() {
        return static_cast<DevFlashFsmInput*>(BaseFsm::getInput());
    }
    inline const DevFlashFsmInput *getInput() const {
        return static_cast<const DevFlashFsmInput*>(BaseFsm::getInput());
    }
    bool allOk() const;
    FsmState getPrefSt() const;

private:
    const DeviceIndex index;
};

QDebug operator<<(QDebug dbg, const DevFlashFsmInput &in);

#endif // DFPFSMDEV_H
