//
//    Copyright 2013 AFI Electronics
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef HRBAPPCONFIG_H
#define HRBAPPCONFIG_H

#include <QMap>

#include "base/DeviceIndex.h"
#include "device-modules/Hrb/HrbTriggerSetup.h"
#include "device-modules/ModularDeviceConfig.h"

class DeviceIndexEnabledMap;
class QSettings;

enum class DeviceFilter {
    All, HRB, TTB
};

struct HrbAppConfig
{
//    void readConfig(QSettings &settings);
//    void writeConfig(QSettings &settings, QString copyPath=QString()) const;
    bool operator ==(const HrbAppConfig &setup) const;
//    QList<GenericSetup> getAll() const;
    double getThreshold() const;
    void setRunState(bool run);
    void setThreshold(double val);
    void spreadGlobalCfg();

    DeviceIndexEnabledMap getDeviceIndexEnabledMap(DeviceFilter filter = DeviceFilter::All) const;
    bool isRun() const;

    ModularDeviceConfig defaultHrb;
    QMap<DeviceIndex, ModularDeviceConfig> hrb;
    QMap<DeviceIndex, ModularDeviceConfig> ttb;
    HrbTriggerSetup triggerSetup;
    bool allowRemoteControl = true;
    bool showAveragedBusy = true;
};
Q_DECLARE_METATYPE(HrbAppConfig)

#endif // HRBAPPCONFIG_H
