#include "ClockUtil.h"

#include <QDateTime>

QDateTime getDateTimeFromClock(const quint64 ts, quint64 *us)
{
    const quint64 TS_FREQ = 125000000;
    double system_ts_real = (double)ts / (double)TS_FREQ;
    quint64 system_ts_s = (quint64)system_ts_real;
    QDateTime date = QDateTime::fromTime_t(system_ts_s);
    if(us)
        *us = (quint64)(1000000 * (system_ts_real - system_ts_s));
    return date;
}

QString getTimeStr(quint64 ms)
{
    QTime t= QTime::fromMSecsSinceStartOfDay(ms);
    QString str;
    int val = t.hour();
    if(val)
        str.append(QString("%1:").arg(val,2,10,QChar('0')));
    val = t.minute();
    if(val || !str.isEmpty())
        str.append(QString("%1:").arg(val,2,10,QChar('0')));
    str.append(QString("%1.%2")
               .arg(t.second(),2,10,QChar('0'))
               .arg(t.msec(),3,10,QChar('0')));
    return str;
}
