//
//    Copyright 2013 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "HRBDeviceOps.h"
#include "regio/regop.h"
#include "HRBRegs.h"

RegOpVector HRBDeviceOps::opDacWrite(int ch, int data)
{
    if (data < 0) data = 0;
    if (data > 4095) data = 4095;
    ch = 7 - ch;
    RegOpVector v;
    v.RegWrite16(REG_THR_DAC, 0x803F);
    v.RegWrite16(REG_THR_DAC, (((ch&0x7)<<12) | (data&0xFFF)));
    return v;
}
