#ifndef HRBDEVICEGLOBAL_H
#define HRBDEVICEGLOBAL_H

#include "mstream-mreg-dev-global/MstreamMregDevGlobal.h"

#include "HrbStatus.h"

class HrbDevice;
struct MStreamStat;

class HrbDeviceGlobal : public MstreamMregDevGlobal
{
    Q_OBJECT
public:
    explicit HrbDeviceGlobal(const DeviceIndex &index, QObject *parent = nullptr);

    HrbStatus getDevStatus() const { return devStatus; }
    HrbStatus getLastMetricDevStatus() const { return lastMetricDevStatus; }
    void updateLastMetricDevStatus() { lastMetricDevStatus = devStatus; }

signals:
    void msdumpReseted(const DeviceIndex &index, int seqNum) const;

    void runError(const DeviceIndex &index, const QString &err) const;

public slots:
    void deviceStatusUpdated(const HrbStatus &status);

private:
    bool isHrbStatusOk(const HrbStatus &status, bool silent = false);

private:
    HrbStatus devStatus;
    HrbStatus lastMetricDevStatus;
    QString errStrCache;
    bool lookForStop = false;
    quint32 stopEvNum = 0;
    bool isRun = false;
};

#endif // HRBDEVICEGLOBAL_H
