#ifndef TTBSTATUS_H
#define TTBSTATUS_H

#include <QMetaType>
#include <QMap>

#include "ModularDeviceStatus.h"
#include "base/DeviceIndex.h"
#include "base/fw_version.h"
#include "config/params.h"

//struct TtbStatistic
//{
//    void clear() {
//////        evNumAll=0;
//////        evNumCandidateRun=0;
//////        evNumAccepted=0;
////        timeValidLoss=0;
////        rxCodeError=0;
////        pllUnlockCnt=0;
////        runStatistic.clear();
//    }

//////    quint64 evNumAll;
//////    quint64 evNumCandidateRun;
//////    quint64 evNumAccepted;
////    quint32 timeValidLoss;
////    quint32 rxCodeError;
////    quint32 pllUnlockCnt;
////    RunStatistic runStatistic;
//};

//struct TtbStatus
//{
//    TtbStatus()
//    {
//        clear();
//    }
//    void clear() {
//        statistic.clear();
////        status=0;
////        desStatus.clear();
////        connected = false;
////        runFinished=true;
//    }

//    DeviceIndex index;
//    QString fwStr; // Reg 0x56/0x57, FW_VER/FW_REV, 16-bit, firmware version/revision number, RO
////    quint16 mcuVer = 0;
////    quint16 mcuRev = 0;
////    bool connected = false;
////    int tdcNCh=0;
////    AdcCoreStatus adcCoreStatus;
////    TrigStatus trigStatus;
////    bool runFinished = false;
////    QMap<int, double> temp;
////    quint16 status = 0; // 0x2 TM Time Valid
////    quint64 wrTime = 0;
////    DeserializersControlStatus desStatus;
////    quint16 pllStatus = 0;
////    bool mstreamMultiAck = false;
////    quint8 mstreamHwBufSize = 8;
////    QVector<double> hitRate;
////    QVector<HptdcStatus> hptdcStatus;

//    TtbStatistic statistic;
//};
//Q_DECLARE_METATYPE(TtbStatus)














struct TtbStatistic
{
    TtbStatistic() {
        clear();
    }
    void clear() {
        ettcError=0;
        ttcTrig=0;
        ethRxError=0;
        ethTxError=0;
        ethRegioError=0;
        ethRegioTimeout=0;

        spillCnt=0;
        ttbBusyCnt=0;
        for(int ch=0; ch< TTB_CH_COUNT; ++ch) {
            linkUp[ch]=0;
            linkError[ch]=0;
            linkTimeout[ch]=0;
            linkErrDisable[ch]=0;

            linkErrDisableBusySet[ch]=0;
            linkErrDisableBusyUnset[ch]=0;
            linkErrDisableBusyMStream[ch]=0;

            chBusyCnt[ch]=0;
        }
    }
    friend bool operator==(const TtbStatistic& l, const TtbStatistic& r) = default;

    quint32 ettcError;
    quint32 ttcTrig;
    quint32 ethRxError;
    quint32 ethTxError;
    quint32 ethRegioError;
    quint32 ethRegioTimeout;

    quint32 linkUp[TTB_CH_COUNT];
    quint32 linkError[TTB_CH_COUNT];
    quint32 linkTimeout[TTB_CH_COUNT];
    quint32 linkErrDisable[TTB_CH_COUNT];

    quint32 linkErrDisableBusySet[TTB_CH_COUNT];
    quint32 linkErrDisableBusyUnset[TTB_CH_COUNT];
    quint32 linkErrDisableBusyMStream[TTB_CH_COUNT];

    quint64 spillCnt;
    quint64 ttbBusyCnt;
    quint64 chBusyCnt[TTB_CH_COUNT];

    TtbStatistic & operator-=(const TtbStatistic& st);
};

struct TtbStatus: public ModularDeviceStatus
{
    explicit TtbStatus(const DeviceIndex &deviceIndex = {})
        : ModularDeviceStatus(deviceIndex)
    {
        clear();
    }

    void clear() {
        ettc_clock_ok=false;
        ettc_ok=false;
        rjttc_clock_ok=false;
        xoff=false;
        ettc_spill=false;

        hostStr.clear();
        fw = fw_version_t();
        fwStr.clear();
        spillNum=0;
        eventNR=0;
        globEvNum=0;
        systemTs=0;
        statistic.clear();

        linkEn=0;
        linkUp=0;
        errDisableEn=0;
        linkErrdisable=0;
        linkBusy=0;
    }
    friend bool operator==(const TtbStatus& l, const TtbStatus& r) = default;

    // REG_TTB_CSR_STATUS
    bool ettc_clock_ok; // 1
    bool ettc_ok; // 2
    bool rjttc_clock_ok; // 4
    bool xoff; // 8
    bool ettc_spill; // A

    QString hostStr;
    fw_version_t fw;
    QString fwStr;
    quint32 spillNum;
    quint32 eventNR;
    quint64 globEvNum;
    quint64 systemTs;
    TtbStatistic statistic;

    quint16 linkEn; // 0:TTB_NCH bits of state
    quint16 linkUp; // 0:TTB_NCH bits of state
    quint16 errDisableEn; // 0:TTB_NCH bits of state
    quint16 linkErrdisable; // 0:TTB_NCH bits of state
    quint16 linkBusy; // 0:TTB_NCH bits of state

    TtbStatus & operator-=(const TtbStatus& st);
};
Q_DECLARE_METATYPE(TtbStatus)

#endif // TTBSTATUS_H
