#include "EvBApp.h"

#include <QCommandLineParser>
#include <QPixmap>

#include "base/Globals.h"

EvBApp::EvBApp(int &_argc, char *_argv[])
    : DaqGuiApp(_argc, _argv)
    , telnetPortOption("telnetRcPort", "Set porn number for Troitsk's RemoteControl",
      "telnetRcPort")
{
    Globals::setDaqModuleType(DaqModule::Type::EventBuilder);
}

void EvBApp::setupOptions()
{
    DaqGuiApp::setupOptions();
    options <<telnetPortOption;
}

void EvBApp::processParseResults(QCommandLineParser &parser)
{
    DaqGuiApp::processParseResults(parser);

    if(parser.isSet(telnetPortOption)) {
        bool ok;
        so.telnetPort = parser.value(telnetPortOption).toUInt(&ok);
        if(!ok)
            parser.showHelp();
    }
}
