#include "MpdTluDevice.h"

#include "TluTtlIoControl/TluTtlIoControlModule.h"

MpdTluDevice::MpdTluDevice(const DeviceIndex &index, QObject *parent)
    : ModularMregDevice(index, statusCache, parent)
    , statusCache(index)
{}

MpdTluDevice::~MpdTluDevice()
{
}

void MpdTluDevice::on_deviceConnected()
{
    ModularMregDevice::on_deviceConnected();

    if (auto ttlModule = getFirstModule<TluTtlIoControlModule>()) {
        const auto &cfg = ttlModule->getInitConfig();
        if(cfg)
            emit ttlIoStartupCfg(getDeviceIndex(), *cfg);
    }
}
