#ifndef MSCMODELITEM_H
#define MSCMODELITEM_H

#include "base/DeviceIndex.h"

struct MscModelItem
{
    explicit MscModelItem(MscModelItem *p = nullptr) : parent(p) {
        if(p)
            index = p->index;
    }
    ~MscModelItem() {
        qDeleteAll(children);
    }
    MscModelItem *child(int row) const { return children.value(row, nullptr); }
    void addChild(MscModelItem *child) { children.push_back(child); }
    int childCount() const { return children.size();}
    int row() const {
        if(parent)
            return parent->children.indexOf(const_cast<MscModelItem*>(this));
        return 0;
    }

    DeviceIndex index;
    int item_row=-1;
    MscModelItem *parent;
    QVector<MscModelItem *> children;
};

#endif // MSCMODELITEM_H
