#ifndef MSCSTREAMCFGFORM_H
#define MSCSTREAMCFGFORM_H

#include "base/DeviceIndex.h"
#include "lib-common/BaseDeviceAppConfig.h"
#include <QWidget>

namespace Ui {
class MscStreamCfgForm;
}

class ConfigKey;

class MscStreamCfgForm : public QWidget
{
    Q_OBJECT

public:
    explicit MscStreamCfgForm(QWidget *parent = nullptr);
    ~MscStreamCfgForm() override;

signals:
    void configChanged(const BaseDeviceAppConfig &config);

public slots:
    void setConfig(const ConfigKey &configKey, const BaseDeviceAppConfig &newConfig);
    void setCurDevice(const DeviceIndex &i);

private slots:
    void on_checkBoxStreamEn_toggled(bool checked);
    void on_checkBoxStreamMask_toggled(bool checked);
    void on_spinBoxStreamStep_valueChanged(int arg1);

    void ceMonitorToggled(bool checked);

private:
    void updateGui() const;
    void updateGroupBoxCeMonitor(const MscStreamConfig &dc) const;
    MscStreamConfig &currentConfig();
    const MscStreamConfig &currentConfig() const;

    Ui::MscStreamCfgForm *ui;

    DeviceIndex curDevice;
    BaseDeviceAppConfig config;
};

#endif // MSCSTREAMCFGFORM_H
