/*
**    Copyright 2014-2015 Ivan Filippov
**    Copyright 2014-2022 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef RCCONFIG_H
#define RCCONFIG_H

#include <QMap>
#include <QString>
#include <QMetaType>

#include "RcTrigDeviceConfig.h"
#include "SlowControlConfig.h"
#include "VmeTrigConfig.h"
#include "base/DeviceIndex.h"
#include "lib-common/RunControlAppConfig.h"

using RcVmeTrigs = QMap<DeviceIndex, VmeTrigConfig>;

class QDebug;

struct RcConfig: public RunControlAppConfig
{
    friend bool operator==(const RcConfig &, const RcConfig &) = default;
    DeviceIndex findVmeDeviceIndexBySerial(quint64 serial) const;

    int extTrigChannelCount() const;

    RcTrigDeviceConfig rcTrigConfig;
    RcVmeTrigs vmeTrigs;
    SlowControlConfig scConfig;
};

Q_DECLARE_METATYPE(RcConfig)

#endif // RCCONFIG_H
