/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef RCTRIGDEVICECONFIG_H
#define RCTRIGDEVICECONFIG_H

#include <QMetaType>
#include <QMap>

#include "SpillPlotConfig.h"
#include "TrigSourceConfig.h"
#include "device-modules/ModularDeviceConfig.h"

using RcXoffChannelDescr = QMap<int, QString>;

struct RcTrigDeviceConfig: public ModularDeviceConfig
{
    friend bool operator==(const RcTrigDeviceConfig &, const RcTrigDeviceConfig &) = default;

    RcXoffChannelDescr channelDescr;
    TrigSourceConfig trig;
    SpillPlotConfig spillPlot;
};

Q_DECLARE_METATYPE(RcTrigDeviceConfig)

#endif // RCTRIGDEVICECONFIG_H
