/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef VMETRIGSCORE_H
#define VMETRIGSCORE_H

#include <QObject>

class DeviceDispatcher;
class RcConfigDispatcher;
class VmeTrigsController;

class VmeTrigsCore : public QObject
{
    Q_OBJECT
public:
    explicit VmeTrigsCore(QObject *parent = nullptr);
    virtual ~VmeTrigsCore();
    void setConfigDispatcher(RcConfigDispatcher *p);
    DeviceDispatcher* getDeviceDispatcher() { return deviceDispatcher; }
    VmeTrigsController* getVmeTrigsController() { return vmeTrigsController; }

signals:
    void printFsmInput();

private:
    DeviceDispatcher * const deviceDispatcher;
    VmeTrigsController * const vmeTrigsController;
};

#endif // VMETRIGSCORE_H
