/*
**    Copyright 2020 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "rc_gui_utils.h"

int findComboBoxNearestItem(const QComboBox &cb, double target)
{
    double min = 1e18;
    int index = 0;
    for (int i=0; i < cb.count(); i++) {
        bool ok = false;
        double v = cb.itemData(i).toDouble(&ok);
        if (!ok)
            continue;
        double diff = abs(target-v);
        if (diff < min) {
            min = diff;
            index = i;
        }
    }
    // qInfo() << "target=" << target << ", found index " << index << "min " << min;
    return index;
}
