#ifndef TQDCSIGNALROUTER_H
#define TQDCSIGNALROUTER_H

#include "lib-common/ReadoutAppSignalRouter.h"
#include <QtGlobal>

class ReadoutAppConfigDb;
class TqdcConfigDispatcher;
class TqdcCore;
class TqdcDevice;
class TqdcDeviceGlobal;
class TqdcMainWindow;
class TqdcTelnetRemoteControl;

class TqdcSignalRouter : public ReadoutAppSignalRouter
{
    TqdcSignalRouter();
    Q_DISABLE_COPY_MOVE(TqdcSignalRouter);
public:
    // Singleton
    static TqdcSignalRouter & instance()
    {
        // thread-safe since C++11
        static TqdcSignalRouter obj;
        return obj;
    }

    void setCore(TqdcCore *p);
    void setMainWindow(TqdcMainWindow *p);
    void setConfigDb(ReadoutAppConfigDb *p)
    { tqdcConfigDb = p; }
    void setTelnetRemoteControl(TqdcTelnetRemoteControl *p)
    { telnetRc = p; }

    void connect_TqdcDeviceGlobal(const TqdcDeviceGlobal * devGlob, const TqdcDevice *dev) const;
    void connectAll() const override;

private:
    void connect_ConfigurationDispatcher() const override;
    void connect_Core() const override;
    void connect_FSM() const override;
    void connect_MainWindow() const override;
    void connect_RemoteControlServer() const override;
    void connect_deviceDispatcher() const override;
    void connect_TelnetRemoteControl() const;

    ReadoutAppConfigDb * tqdcConfigDb = nullptr;
    TqdcMainWindow *mainWindow = nullptr;
    TqdcCore *core = nullptr;
    TqdcTelnetRemoteControl *telnetRc = nullptr;
};
#endif // TQDCSIGNALROUTER_H
