#include "TqdcMainWindow.h"
#include "TqdcApp.h"
#include "TqdcCore.h"

#include "base/app/RunGuard.h"
#include "base/Globals.h"
#include "base/ThreadController.h"
#include "mongo/PrintConfigMap.h"

int main(int argc, char *argv[])
{
    Globals::setDaqModuleType(DaqModule::Type::TQDC);
    TqdcApp daqApp(argc, argv);
    daqApp.init();

    if(daqApp.hasConfigListOpt())
        printConfigMap();

    RunGuard::runSingleOrExit();

    int ret = 1;
    {
        TqdcMainWindow *mw = nullptr;
        if (daqApp.isGuiApp()) {
            mw = new TqdcMainWindow;
            mw->show();
        }

        TqdcCore core(daqApp.getStartupOptions());
//        new ThreadController(&core);
        ret = daqApp.exec();
        delete mw;
    }
    return ret;
}
