#ifndef TRCSIGNALROUTER_H
#define TRCSIGNALROUTER_H

#include "lib-common/ReadoutAppSignalRouter.h"
class DeviceMgrFsm;
class ReadoutAppConfigDb;
class DeviceDispatcher;
class TrcCore;
class RemoteControlServer;
class TrcDeviceGlobal;

#ifdef QT_WIDGETS_LIB
class ConfigurationManager;
class TrcMainWindow;
class DiscoverDialog;
class MStreamStatisticDialog;
class RcCountersModel;
class TrcDeviceChModel;

#include <QMap>
#endif

class TrcSignalRouter: public ReadoutAppSignalRouter
{
    TrcSignalRouter();
    Q_DISABLE_COPY_MOVE(TrcSignalRouter)
public:
    // Singleton
    static TrcSignalRouter & instance()
    {
        // thread-safe since C++11
        static TrcSignalRouter obj;
        return obj;
    }

    void setCore(TrcCore *p);
    void setConfigDb(ReadoutAppConfigDb *p)
    { configDb = p; }
#ifdef QT_WIDGETS_LIB
    void setMainWindow(TrcMainWindow *p);
    void setDeviceChModel(TrcDeviceChModel *p)
    { deviceChModel = p; }
    void setRcCountersModel(int type, RcCountersModel *p)
    { rcCountersModels[type] = p; }
#endif

    void connect_TrcDeviceGlobal(const TrcDeviceGlobal * devGlob);

private:
    void connect_ConfigurationDispatcher() const override;
#ifdef QT_WIDGETS_LIB
    void connect_MainWindow() const override;
#endif
    void connect_RemoteControlServer() const override;
    void connect_FSM() const override;

    TrcCore *core = nullptr;
    ReadoutAppConfigDb * configDb = nullptr;
#ifdef QT_WIDGETS_LIB
    TrcMainWindow *mainWindow = nullptr;
    TrcDeviceChModel * deviceChModel = nullptr;
    QMap<int, RcCountersModel *> rcCountersModels;
#endif
};
#endif // TRCSIGNALROUTER_H

