#ifndef RCCOUNTERSMODEL_H
#define RCCOUNTERSMODEL_H

#include <QAbstractTableModel>
#include <QModelIndex>
#include <QVariant>

#include "device-modules/RcCounters/RcCounters.h"

class ConfigKey;
struct BaseDeviceAppConfig;

class RcCountersModel : public QAbstractTableModel
{
    Q_OBJECT
public:
    RcCountersModel(DevCountersTypes t, QObject *parent = nullptr);
    QVariant data(const QModelIndex &index, int role) const override;
    QVariant headerData(int section, Qt::Orientation orientation,
                        int role) const override;
    int rowCount(const QModelIndex &parent = QModelIndex()) const override;
    int columnCount(const QModelIndex &parent = QModelIndex()) const override;

public slots:
    void deviceStatusUpdated(const BaseDevCountersMap &st);
    void setConfig(const ConfigKey &key, const BaseDeviceAppConfig &newConfig);

private:
    void sendDataChanged(QVector<int> roles = QVector<int>());

    QVariant displayData(const QModelIndex &index) const;

    DevCountersTypes type;
    BaseDevCounters dev_status;
    QStringList devChNames;
};

#endif // RCCOUNTERSMODEL_H
