#include "AbstractConfigSample.h"

#include <cstdlib>
#include <ctime>

#include "DeviceId.h"
#include "DeviceIndex.h"
#include "DaqModule.h"
#include "ClientIndex.h"
#include "ProgramIndex.h"
#include "RcRunId.h"
#include "ConfigSelector.h"

// Base
template<>
QString AbstractConfigSample::sample<QString>()
{
    return QString("%1").arg(rand() % 100);
}

template<>
bool AbstractConfigSample::sample()
{
    return std::rand() & 1;
}

template<>
quint8 AbstractConfigSample::sample<quint8>()
{
    return static_cast<quint8>(rand());
}

template<>
qint16 AbstractConfigSample::sample<qint16>()
{
    return static_cast<qint16>(rand());
}

template<>
quint16 AbstractConfigSample::sample<quint16>()
{
    return static_cast<quint16>(rand());
}

template<>
qint32 AbstractConfigSample::sample<qint32>()
{
    return rand();
}

template<>
quint32 AbstractConfigSample::sample<quint32>()
{
    return static_cast<quint32>(rand());
}

template<>
quint64 AbstractConfigSample::sample()
{
    return static_cast<quint64>(sample<qint64>());
}

template<>
qint64 AbstractConfigSample::sample()
{
    return (static_cast<qint64>(rand())<<32) + rand();
}

template<>
double AbstractConfigSample::sample<double>()
{
    return rand();
}


// AFI Core types

template<>
DeviceIndex AbstractConfigSample::sample<DeviceIndex>()
{
    return DeviceIndex(static_cast<DeviceId>(1+(rand() % 0x80)),
                       static_cast<quint64>(rand())
                       | (static_cast<quint64>(rand()) << 16));
}

template<>
DaqModule AbstractConfigSample::sample<DaqModule>()
{
    return DaqModule(static_cast<DaqModule::Type>(1 + (rand() % 20)));
}

template<>
ClientIndex AbstractConfigSample::sample<ClientIndex>()
{
    return ClientIndex(sample<DaqModule>(), sample<ProgramIndex>());
}

template<>
ProgramIndex AbstractConfigSample::sample<ProgramIndex>()
{
    return ProgramIndex("domain_" + sample<QString>(), "index_" + sample<QString>());
}

template<>
RcRunId AbstractConfigSample::sample<RcRunId>()
{
    return RcRunId("runIndex_" + sample<QString>(), rand() / 2, QUuid::createUuid());
}

template<>
ConfigSelector AbstractConfigSample::sample<ConfigSelector>()
{
    return ConfigSelector(sample<DaqModule>(), sample<ConfigIndexName>());
}

template<>
ConfigurationName AbstractConfigSample::sample<ConfigurationName>()
{
    return ConfigurationName("ConfigurationName_" + sample<QString>());
}

template<>
ConfigIndexName AbstractConfigSample::sample<ConfigIndexName>()
{
    return ConfigIndexName(sample<ProgramIndex>(), sample<ConfigurationName>());
}
