#include "ClientIndexEnabledConverter.h"

#include "ClientIndexEnabled.h"
#include "ClientIndexConverter.h"

template<>
bool AbstractConfigConverter<ClientIndexEnabledMap>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<ClientIndexEnabledMap>::toJsonObject(const ClientIndexEnabledMap &in)
{
    return ConfigConverterUtil::toJsonValue(in).toObject();
}

template<>
ClientIndexEnabledMap AbstractConfigConverter<ClientIndexEnabledMap>::fromJsonObject(const QJsonObject &m)
{
    auto map = ConfigConverterUtil::toMap<ClientIndex, bool>(m);
    ClientIndexEnabledMap ret;
    for(auto it=map.cbegin(); it!=map.cend(); ++it) {
        if(it.key().isEmpty()){
            //todo: remove after debug
            qWarning() << __PRETTY_FUNCTION__ << "Convertor error";
            continue;
        }
        ret.insert(it.key(), *it);
    }

    return ret;
}

template<>
QJsonValue AbstractConfigConverter<ClientIndexEnabledMap>::toJsonValue(const ClientIndexEnabledMap &in)
{
    return toJsonObject(in);
}

template<>
ClientIndexEnabledMap AbstractConfigConverter<ClientIndexEnabledMap>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<ClientIndexEnabledMap>::registerSubTypes()
{
    AbstractConfigConverter<ClientIndex>::registerTypes();
}
