#include "RunDocument.h"

#include <QJsonObject>

RunDocument::RunDocument(const RcRunId &runId, const ClientIndex &index, const QJsonObject &cfg)
    : runId(runId)
    , programs({{index, cfg}})
{
}

void RunDocument::setMeta(const ClientIndex &top)
{
    meta.startDateTime = QDateTime::currentDateTime();
    meta.topProgram = top;
}

bool RunDocument::merge(const RunDocument &doc)
{
    if(runId != doc.runId)
        return false;
    programs.insert(doc.programs);
    devHw.insert(doc.devHw);
    devFw.insert(doc.devFw);
    devCal.insert(doc.devCal);
    return true;
}
