/*
**    Copyright 2021 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef SERVICECONFIGURL_H
#define SERVICECONFIGURL_H

#include <QUrl>

class ServiceConfigUrl
{
public:
    ServiceConfigUrl(QString serviceName, QUrl defaultUrl, bool defaultEnable)
        : serviceName(serviceName), defaultUrl(defaultUrl), defaultEnable(defaultEnable) {}
    bool isEnabled() const;
    static bool isEnabled(QString serviceName, bool defaultEnable);
    QUrl getUrl() const;
    static QUrl getUrl(QString environment, QString serviceName, QUrl defaultUrl);

private:
    QString serviceName;
    QUrl defaultUrl;
    bool defaultEnable;
};

#endif // SERVICECONFIGURL_H
