#ifndef RUNGUARD_H
#define RUNGUARD_H

#include <QObject>
#include <QSharedMemory>
#include <QSystemSemaphore>

class ConfigSelector;
class DaqModule;
class ProgramIndex;

class RunGuard
{

public:
    RunGuard(const QString &key);
    RunGuard(const DaqModule &daqModule, const ProgramIndex &program_index);
    ~RunGuard();

    bool tryToRun();

    static void runSingleOrExit();
    static void runSingleOrExit(const DaqModule &daqModule, const ProgramIndex &program_index);

private:
    void release();
    bool isAnotherRunning();

    const QString key;
    const QString memLockKey;
    const QString sharedmemKey;

    QSharedMemory sharedMem;
    QSystemSemaphore memLock;

    Q_DISABLE_COPY( RunGuard )
};

#endif // RUNGUARD_H
