/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef CONFIGURATIONNAME_H
#define CONFIGURATIONNAME_H

#include <QMetaType>
#include <QString>

//using ConfigurationName = QString;

class ConfigurationName : public QString{
public:
    ConfigurationName(const QString &s = _default)
        : QString(s.isEmpty() ? _default : s) {}
    bool isDefault() const { return QString::operator==(_default); }

private:
    static constexpr const char *_default = "default";
};

Q_DECLARE_METATYPE(ConfigurationName)

inline QDataStream &operator<<(QDataStream &out, const ConfigurationName &pod) {
    out<< QString(pod);
    return out;
}

inline QDataStream &operator>>(QDataStream &in, ConfigurationName &pod) {
    QString s;
    in >> s;
    pod = ConfigurationName(s);
    return in;
}

#endif // CONFIGURATIONNAME_H
