/*
**    Copyright 2014-2020 Ivan Filippov
**    Copyright 2014-2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "DiscoverDialog.h"

#include "DiscoverDialog_p.h"

DiscoverDialog::DiscoverDialog(QWidget *parent)
    : QDialog(parent),
      d_ptr(new DiscoverDialogPrivate(this))
{
    setSizeGripEnabled(true);
}

DiscoverDialog::~DiscoverDialog()
{
    delete d_ptr;
}

void DiscoverDialog::accept()
{
    Q_D(DiscoverDialog);
    d->apply();
    QDialog::accept();
}

void DiscoverDialog::setDeviceList(const DeviceIndexEnabledMap &list)
{
    Q_D(DiscoverDialog);
    d->setDeviceList(list);
}
