/*
**    Copyright 2014-2020 Ivan Filippov
**    Copyright 2014-2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DISCOVERDIALOG_H
#define DISCOVERDIALOG_H

#include <QDialog>

#include "base/DeviceIndex.h"

class DiscoverDialogPrivate;
class LldpInfoCache;
struct DeviceIndexEnabledMap;

class DiscoverDialog : public QDialog
{
    Q_OBJECT

public:
    explicit DiscoverDialog(QWidget *parent = nullptr);
    ~DiscoverDialog();

signals:
    void deviceListChanged(const DeviceIndexEnabledMap&);
    void setDeviceIdFilter(const DeviceIdSet &r);
    void lldpCacheUpdated(const LldpInfoCache &cache);

public slots:
    void setDeviceList(const DeviceIndexEnabledMap &);
    virtual void accept() override;

private:
    Q_DECLARE_PRIVATE(DiscoverDialog)
    DiscoverDialogPrivate * const d_ptr;
};

#endif // DISCOVERDIALOG_H
