/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "HitCoreStatus.h"
#include "sdb/AfiSdbId.h"
#include "device-modules/RegWrTimeTai.h"

bool HitCoreStatus::isValid() const
{
    return (id == AFI_SDB_Input_Hit_Core)
        && (nch > 0 && nch <= 128);
}

TaiTime HitCoreStatus::taiTime() const
{
    return RegWrTaiTime::fromRaw(ts);
}

HitCoreStatus& HitCoreStatus::operator-=(const HitCoreStatus& r)
{
    ts = RegWrTaiTime::toRaw(taiTime() - r.taiTime());
    for (int i=0; i<std::min(cnt.size(), r.cnt.size()); i++) {
        cnt[i] -= r.cnt[i];
    }
    return *this;
}
