#include "MscInputConfigConverter.h"

#include "base/ConfigConverterUtil.h"

#include "MscInputConfig.h"

namespace {
constexpr const char *k_histCh = "histCh";
constexpr const char *k_ceLut = "ceLut";
constexpr const char *k_histLut = "histLut";
}

template<>
bool AbstractConfigConverter<MscInputChConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<MscInputChConfig>::toJsonObject(const MscInputChConfig &in)
{
    QVariantMap m;
    m[k_histCh] = QVariant::fromValue(in.histCh);
    m[k_ceLut] = QVariant::fromValue(in.ceLut);
    m[k_histLut] = QVariant::fromValue(in.histLut);
    return fromVariantMap(m);
}

template<>
MscInputChConfig AbstractConfigConverter<MscInputChConfig>::fromJsonObject(const QJsonObject &in)
{
    MscInputChConfig out;
    update_value(in, k_histCh, &out.histCh);
    update_value(in, k_ceLut, &out.ceLut);
    update_value(in, k_histLut, &out.histLut);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<MscInputChConfig>::toJsonValue(const MscInputChConfig &in)
{
    return toJsonObject(in);
}

template<>
MscInputChConfig AbstractConfigConverter<MscInputChConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<MscInputChConfig>::registerSubTypes()
{}
