#include "StatPreset.h"

StatPreset::StatPreset()
{
    type = STAT_DEFAULT;
    label = "default";
    regs
        << 0x004B // Board Temperature, RO
        << 0x004C // F/W Version, RO
        << 0X004D // F/W Revision, RO

        << 0x4001 // MCU
        << 0x4002
        << 0x4003
        << 0x4004
        << 0x4005
        << 0x4006
        << 0x4007
        << 0x4008
        << 0x4009
        << 0x400A
        << 0x400B
        << 0x400C;
}

StatPreset StatPresetFabric::getPreset(int type)
{
    StatPreset sp;
    sp.type = static_cast<StatPreset::STAT_TYPE>(type);
    switch (type) {
    case StatPreset::STAT_DEBUG: {
        sp.label = "debug";
        return sp;
    }
    case StatPreset::STAT_Test: {
        sp.label = "test";
        sp.regs.clear();
        return sp;
    }
    case StatPreset::STAT_DEFAULT:
        return sp;
    }
    return {};
}

StatPreset StatPresetFabric::getPreset(const QString &label)
{
    if (label.isEmpty())
        return {};
    const auto &allPresets = StatPresetFabric::getAllPresets();
    for (const auto &p : allPresets) {
        if (p.label == label)
            return p;
    }
    return {};
}

QList<StatPreset> StatPresetFabric::getAllPresets()
{
    QList<StatPreset> all_presets;
    for (int i = 0; i < StatPreset::STAT_PRESET_CNT; ++i)
        all_presets << getPreset(i);
    return all_presets;
}
