#ifndef TLU16SFPTRIGGERMODULE_H
#define TLU16SFPTRIGGERMODULE_H

#include "device-modules/BaseDeviceModule.h"

#include <optional>

#include "Tlu16SfpTriggerConfig.h"
#include "Tlu16SfpTriggerBuildParams.h"

class Tlu16SfpTriggerModule : public BaseDeviceModule<Tlu16SfpTriggerModule>
{
public:
    explicit Tlu16SfpTriggerModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const Tlu16SfpTriggerConfig &config);
    std::optional<Tlu16SfpTriggerBuildParams> getBuildParam() const
    {
        return buildParams;
    }

protected:
    void post_init() override;

private:
    std::optional<Tlu16SfpTriggerBuildParams> buildParams;
};

#endif // TLU16SFPTRIGGERMODULE_H
