#ifndef TLU40LVDSLUMINOSITYMODULE_H
#define TLU40LVDSLUMINOSITYMODULE_H

#include "device-modules/BaseDeviceModule.h"

#include <optional>

#include "Tlu40LvdsLuminosityBuildParams.h"
#include "Tlu40LvdsLuminosityConfig.h"
#include "Tlu40LvdsLuminosityStatus.h"

class Tlu40LvdsLuminosityModule : public BaseDeviceModule<Tlu40LvdsLuminosityModule>
{
public:
    explicit Tlu40LvdsLuminosityModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const Tlu40LvdsLuminosityConfig &config);
    std::optional<Tlu40LvdsLuminosityStatus> readStatus();
    std::optional<Tlu40LvdsLuminosityBuildParams> getBuildParam() const {
        return buildParams;
    }

protected:
    void post_init() override;

private:
    std::optional<Tlu40LvdsLuminosityBuildParams> buildParams;
};

#endif // TLU40LVDSLUMINOSITYMODULE_H
