#include "PhyResetButtonDelegate.h"

#include <QPushButton>

#include "FeLinkTreeModelItem.h"

namespace {
constexpr auto k_dev = "dev";
constexpr auto k_ch = "ch";
}

QWidget *PhyResetButtonDelegate::createEditor(QWidget *parent,
                                              const QStyleOptionViewItem &/*option*/,
                                              const QModelIndex &index) const
{
    auto item = getItemByIndex(index);
    if(!item)
        return {};

    QString name = "All";
    if(!item->dev.isNull())
        name = item->dev.getSerialStr();
    if(item->ch != -1)
        name = QString("ch:%1").arg(item->ch);
    auto button = new QPushButton(name, parent);

    connect(button, &QPushButton::clicked,
            this, &PhyResetButtonDelegate::buttonClicked);
    button->setProperty(k_dev, QVariant::fromValue(item->dev));
    button->setProperty(k_ch, item->ch);

    return button;
}

// void PhyResetButtonDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
// {
// }

// void PhyResetButtonDelegate::setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const
// {
// }

#include <QDebug>
void PhyResetButtonDelegate::buttonClicked() const
{
    auto button = qobject_cast<QPushButton*>(sender());
    if(!button)
        return;

    bool ok;
    auto dev = button->property(k_dev).value<DeviceIndex>();
    auto ch = button->property(k_ch).toInt(&ok);
    qInfo() << __PRETTY_FUNCTION__ << dev << ch;
    emit phyReset(dev, ch);
}

FeLinkTreeModelItem *PhyResetButtonDelegate::getItemByIndex(const QModelIndex &index) const
{
    return static_cast<FeLinkTreeModelItem*>(index.internalPointer());
}
