#ifndef HPTDCSTATUSMODELITEM_H
#define HPTDCSTATUSMODELITEM_H

#include "base/DeviceIndex.h"

#include "HptdcStatusMetrics.h"

class HptdcStatusModelItem
{
public:
    explicit HptdcStatusModelItem(HptdcStatusModelItem *p = nullptr) : parent(p) {
        if(p)
            dev = p->dev;
    }
    ~HptdcStatusModelItem() {
        qDeleteAll(children);
    }
    HptdcStatusModelItem *child(int row) const { return children.value(row, nullptr); }
    void addChild(HptdcStatusModelItem *child) { children.push_back(child); }
    int childCount() const { return children.size();}
    int row() const {
        if(parent)
            return parent->children.indexOf(const_cast<HptdcStatusModelItem*>(this));
        return 0;
    }

    DeviceIndex dev;
    HptdcStatusMetrics metric;
    HptdcStatusModelItem *parent;
    QVector<HptdcStatusModelItem *> children;
};

#endif // HPTDCSTATUSMODELITEM_H
