/*
**    Copyright 2021 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef METRICTYPES_H
#define METRICTYPES_H

#include <QMap>
#include <QVariant>
#include <QMetaType>

#define MetricFields QMap<QString, QVariant>
#define MetricTags QMap<QString, QString>

struct MetricEntity {
    MetricEntity() = default;
    MetricEntity(const QString &measurement, const MetricFields &fields, const MetricTags &tags)
        : measurement(measurement), fields(fields), tags(tags)
    {}
    QString measurement;
    MetricFields fields;
    MetricTags tags;
};

Q_DECLARE_METATYPE(MetricEntity);

#endif // METRICTYPES_H
