/*
**    Copyright 2011-2022 Ivan Filippov
**    Copyright 2011-2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef ADCEVENTTRIGINFO_H
#define ADCEVENTTRIGINFO_H

#include <QMap>

struct BaseFragment;

struct AdcEventTrigInfo {
    AdcEventTrigInfo() { clear(); }
    void clear() {
        workedChannels=0;
        currentChannels=0;
        fragments.clear();
        totalDataSize=0;
        gotInfo=false;
        trigFrag=nullptr;
        free = true;
        evNum = 0;
    }
    quint64 workedChannels = 0;
    quint64 currentChannels = 0;
    QMap<quint8, BaseFragment *> fragments; // channel to fragmentId with this ch.
    quint32 totalDataSize = 0; // Sum of pure RawData
    bool gotInfo = false;
    BaseFragment *trigFrag = nullptr;
    bool free = true;
    quint32 evNum = 0;
};

#endif // ADCEVENTTRIGINFO_H
