#ifndef ADDPNPMODEL_H
#define ADDPNPMODEL_H

#include <QAbstractTableModel>

#include "AddPnpComboBoxFilter.h"
#include "pnp-server/PNPMessage.h"

class AddPnpModel : public QAbstractTableModel
{
    Q_OBJECT
public:
    AddPnpModel(QObject *parent = nullptr);
    QVariant data(const QModelIndex &index, int role) const override;
    QVariant headerData(int section, Qt::Orientation orientation,
                        int role) const override;
    int rowCount(const QModelIndex &parent = QModelIndex()) const override;
    int columnCount(const QModelIndex &parent = QModelIndex()) const override;

public slots:
    void setCache(const PnpInfoCache &cache);
    void setComboBoxFiler(const AddPnpComboBoxFilter &f);

private:
    void refreshFilter();
    PnpInfoCache filteredProgs();
    QVariant displayData(const ProgramDescription *pd, int col) const;
    QVariant userData(const ProgramDescription *pd, int col) const;

    const ProgramDescription *indexToPd(const QModelIndex &index) const;
    QModelIndex uuidToModeIndex(const QUuid &uuid) const;

    PnpInfoCache pnpCache;
    PnpInfoCache pnpFiltred;
    AddPnpComboBoxFilter cbFilter;
};

#endif // ADDPNPMODEL_H
