#include "PnpDiscoveryFilter.h"
#include "PnpDiscovery.h"

void PnpDiscoveryFilter::pnpCacheUpdated(const PnpInfoCache &cache)
{
    if (filter.isEmpty()) {
        emit pnpCacheUpdatedFiltered(cache);
        return;
    }
    PnpInfoCache result;
    for (auto it = cache.begin(); it != cache.end(); ++it) {
        auto daq_module = it.value().getDaqModule();
        if (filter.contains(daq_module))
            result.insert(it.key(), it.value());
    }
    emit pnpCacheUpdatedFiltered(result);
}
